//
//  NewsTableViewController.m
//  RhinoGold
//
//  Created by Rafael Del Molino on 3/17/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "NewsTableViewController.h"
#import "NewsDetailViewController.h"
#import "SBJsonParser.h"

@implementation NewsTableViewController

@synthesize CellClick;
@synthesize feeds;
@synthesize myArray;

static NSString *searchAPI = @"http://blog.rhinogold.com/?json=1&count=10&include=title,date,url";


// Agafa el feed
-(NSString*)getSearch{
    
    NSError *error;
    NSString *searchString = [NSString stringWithContentsOfURL:[NSURL URLWithString:searchAPI] encoding:NSUTF8StringEncoding error:&error];
    return searchString;
}

// Parseja el XML
-(NSArray*)parseFeed:(NSString*)stringData{
    SBJsonParser *parser = [[SBJsonParser alloc] init];
    NSArray *result = [NSArray arrayWithArray:[[parser objectWithString:stringData] valueForKey:@"posts"]];
    // [parser release];
    return result;
}

-(void)updateTableWithArray:(NSArray*) array{
    
    int cont = [array count];
    
    myArray = [[NSMutableArray alloc] init];
    
    for (int i =0;i<cont;i++)
    {
        NSDictionary *item = [array objectAtIndex:i];
         
        dades *datos;
        NSString *titul;
        NSString *data;
        NSString *url;
        titul =  [item valueForKey:@"title"];
        data =  [item valueForKey:@"date"];
        url =  [item valueForKey:@"url"];
        
        // Parsejem la fecha
        // NSString to NSDate
        NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
        // this is imporant - we set our input date format to match our input string
        // if format doesn't match you'll get nil from your string, so be careful
        [dateFormatter setDateFormat:@"yyyy-MM-dd HH:mm:ss"];
        NSDate *dateFromString = [[NSDate alloc] init];
        dateFromString = [dateFormatter dateFromString:data];
        
        NSDateFormatter *dateFormatter2 = [[NSDateFormatter alloc] init];
        [dateFormatter2 setDateStyle:NSDateFormatterFullStyle];
        NSString* currentTime = [dateFormatter2 stringFromDate:dateFromString];

        NSMutableDictionary *myDictionary = [[ NSMutableDictionary alloc] init];
        [ myDictionary setObject:titul forKey:@"title"];
        [ myDictionary setObject:url forKey:@"url"];
        [ myDictionary setObject:currentTime forKey:@"date"];
        
        [myArray addObject:myDictionary];
        
        
    }
    self.feeds = array;
}



- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];

    NSString *stringData = [self getSearch];
    NSArray *array = [self parseFeed:stringData];
    [self updateTableWithArray:array];
    
}

- (void)viewDidUnload
{
    [self setCellClick:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{

    // Return the number of rows in the section.
    return [myArray count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"newscells";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
    }
    
 
    cell.textLabel.text = [[myArray objectAtIndex:indexPath.row] objectForKey:@"title"];
   cell.detailTextLabel.text = [[myArray objectAtIndex:indexPath.row] objectForKey:@"date"];
    // Configure the cell...
    
    return cell;
}

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/

/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/

/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
{
}
*/

/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

-(void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
    NSLog(@"prepareForSegue");


    NewsDetailViewController *eventDetail = (NewsDetailViewController*)segue.destinationViewController;
    UITableViewCell *selectedCell = sender;
    NSInteger selectedIndex = [self.tableView indexPathForCell:selectedCell].row;
    
    eventDetail.myArray = self.myArray;
    eventDetail.m_index = selectedIndex;
   // eventDetail.event = [events objectAtIndex:selectedIndex];
    NSLog(@"segue: %@, sender: %@", [segue description], [sender description]);



}

#pragma mark - Table view delegate

//- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
//{
//    
//    
//    // Navigation logic may go here. Create and push another view controller.
//  
//
//    NewsTableViewController *detailViewController = [[NewsTableViewController alloc] initWithNibName:nil bundle:nil];
//     // Pass the selected object to the new view controller.
//    [self.navigationController pushViewController:detailViewController animated:YES];
//        
//}
//


@end
